## Набор ролей приложений Cartridge для проекта Уроборос

Cartridge-приложение для упаковки в rock. Содержит две роли:
- topology: роль для получения топологии кластера, vshard-групп и спейсов в них;
- replicator: роль для выполнения функций репликации.

### Роль uroboros.roles.uroboros-topology

Роль зависит от роли `cartridge.roles.vshard-router`. Поднимает следующие HTTP-эндпойнты:
1. `GET /uroboros/api/v1/topology`.
2. `GET /uroboros/api/v1/health`.
3. `GET /uroboros/api/v1/space/<vshard_group>/<space_name>`.
4. `POST /uroboros/api/v1/user`.

Эндпойнт `GET /uroboros/api/v1/topology` возвращает в ответ топологию кластера в формате JSON со следующей структурой:

```json
[
    {
        "name" = string,
        "bucket_count" = int,
        "replicasets" = [
            {
                "uuid" = string,
                "alias" = string,
                "is_storage" = bool,
                "is_router" = bool,
                "servers" = {
                    {"uuid" = string, "uri" = string, "is_leader" = bool}
                    ...
                },
                "spaces" = [
                    {
                        "space_id" = int,
                        "space_name" = string,
                        "bucket_id_index" = int
                    },
                    ...
                ],
                "vshard_group" = string
            },
            ...
        ]
    }
    ...
]
```

Эндпойнт `GET /uroboros/api/v1/health` предназначен для хелсчека роли.

Эндпойнт `GET /uroboros/api/v1/space/<vshard_group>/<space_name>` предназначен для получения информации о спейсе. Схема ответа:

```json
{
    "name" = string,
    "space" = hex,
    "indexes" = [
        hex,
        hex,
        ....
    ]
}
```

Эндпойнт `POST /uroboros/api/v1/user` принимает параметр `new_pass` (строка). При вызове роль убеждается в наличии специального пользователя для репликации. Если пользователь существует, то его пароль будет изменен. В противном случае пользователь будет создан.

Эндпойнт `/uroboros/api/v1/health` предназначен для хелсчека роли.

### Роль uroboros.roles.uroboros-replicator

Роль зависит от роли `cartridge.roles.vshard-storage` и предназначена для выполнения операций репликации DML и DDL. Она должна быть развернута на всех инстансах, входящих в состав репликасетов с шардированными хранилищами. Содержит функции для выполнения DML операций REPLACE и DELETE, для выполнения которых используется созданный в рамках работы проекта специальный пользователь для репликации (см. роль выше). Также роль модифицирует метрики мастера в репликасете, добавляя в них метки `replicaset_alias` и `replicaset_uuid`